<?php
/*
Threshold plugin 2.1a for cacti 8.6c

Copyright 2005 Aurelio DeSimone
adesimone@ciscoconfigbuilder.com
http://www.ciscoconfigbuilder.com

Many contributions from Ranko Zivojnovic <ranko@spidernet.net>

Some code may have been used from other parts of cacti - copyright of Ian Berry
*/

include("./include/auth.php");
include("./include/top_graph_header.php");

$sql = "SELECT * FROM thold_data ORDER BY thold_alert DESC, bl_alert DESC, rra_id ASC";

$result = mysql_query($sql) or die (mysql_error());

$alerts_only=(read_config_option("alert_show_alerts_only") == "on");
$show_hosts=(read_config_option("alert_show_host_status") == "on");
?>
<center> Last Poll:
<?php 
$myrows=mysql_fetch_array(mysql_query("SELECT * FROM tholdset"));
echo $myrows["datet"];
?>
</center>
<br>
<table width="98%" border="0" align="center">
<thead>
<tr bgcolor="#a0a0ff">
<?php
if($show_hosts) {
?>
<td align="center">Hosts</td>
<?php
}
?>
<td align="center">Thresholds</td>
</tr>
</thead>
<tbody>
<tr>
<?php
if($show_hosts) {
?>
<td width="25%" valign="top">
  <table width="90%" class="list" align="center" cellpadding="3">
    <thead>
    <tr bgcolor="#a0a0ff">
    <td>Host</td>
    <td>Status</td>
    </tr>
    </thead>
    <tbody>
<?php
$host_table = db_fetch_assoc("select * from host order by status asc");
$c=0;
foreach($host_table as $host) {
        if($host["disabled"] == "on") continue;
	
	$c++;
	
	switch($host["status"]) {
		case HOST_UNKNOWN:
		$color = "gray";
		$status = "Unknown";
		break;
		case HOST_DOWN:
		$color = "red";
		$status = "DOWN";
		break;
		case HOST_RECOVERING:
		$color = "yellow";
		$status = "Recovering";
		break;
		case HOST_UP:
		$color = "green";
		$status = "up";
		break;
	}
	if($alerts_only && $color == "green") continue;

	echo "<tr" . ($c % 2 == 1 ? " bgcolor='#E5E5E5'" : "") . ">\n";
	echo "  <td>\n";
	echo $host["description"];
	echo "  </td>\n";
	echo "  <td bgcolor='$color'>\n";
	echo $status;
	echo "  </td>\n";
	echo "</tr>\n";
}
?>
    </tbody>
  </table>
</td>
<?php
}
?>
<td width="75%" valign="top">
<table class="list" align="center" cellpadding="3">
<thead>
<tr bgcolor="#a0a0ff">
<td>ID</td>
<td>Description / Click for graph</td>
<!--<td>Graph ID</td>-->
<td>High Threshold</td>
<td>Low Threshold</td>
<td>Baselining</td>
<td>Current</td>
<td>Currently Triggered</td>
</tr>
</thead>
<tbody>
<?php
$c=0;
while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$c++;
	$t = db_fetch_assoc("select id,name,name_cache from data_template_data where local_data_id=" . $row["rra_id"] . " LIMIT 1");
	$desc_rra = $t[0]["name_cache"];
	unset($t);
	$ds_item_desc = db_fetch_assoc("select id,data_source_name from data_template_rrd where id = " . $row["data_id"]);
	$t = db_fetch_assoc("select element from thold where rra=" . $row["rra_id"] . " LIMIT 1");
	$graph_id = $t[0]["element"];
	if ($row["thold_alert"] != 0) {
		$alertstat="YES";
		$bgcolor=($row["thold_fail_count"] >= $row["thold_fail_trigger"] ? "red" : "yellow");
	} else {
		$alertstat="no";
		$bgcolor="green";

		if($row["bl_enabled"] == "on") {
		if($row["bl_alert"] == 1) {
                                $alertstat="baseline-LOW";
                                $bgcolor=($row["bl_fail_count"] >= $row["bl_fail_trigger"] ? "orange" : "yellow");
                                } elseif($row["bl_alert"] == 2)  {
                                $alertstat="baseline-HIGH";
                                $bgcolor=($row["bl_fail_count"] >= $row["bl_fail_trigger"] ? "orange" : "yellow");
                        }

		}
	};
	
	if($alerts_only && $bgcolor == "green") continue;
?>
<tr<?=($c % 2 == 1 ? " bgcolor='#E5E5E5'" : "")?>>	<td><?=$row["id"]?></td>
        <td><a href="./graph.php?local_graph_id=<?=$graph_id?>&rra_id=all"><?=$desc_rra?> [<?=$ds_item_desc[0]["data_source_name"]?>]</a></td>
<!--	<td><a href="./graph.php?local_graph_id=<?=$graph_id?>&rra_id=all"><?=$graph_id?></a></td> -->
        <td<?=($row["thold_alert"] == 2 ? (" bgcolor='" . $bgcolor . "'") : "")?>><?=($row["thold_hi"] == "" ? "n/a" : $row["thold_hi"])?></td>
        <td<?=($row["thold_alert"] == 1 ? (" bgcolor='" . $bgcolor . "'") : "")?>><?=($row["thold_low"] == "" ? "n/a" : $row["thold_low"])?></td>
	<td<?=(($row["bl_enabled"] == "on" && $row["bl_alert"] > 0) ? (" bgcolor='" . $bgcolor . "'") : "")?>><?=$row["bl_enabled"]?></td>
	<td<?=($bgcolor ? (" bgcolor='" . $bgcolor . "'") : "")?>><?=$row["lastread"]?></td>
	<td bgcolor="<?php echo $bgcolor ?>"><?php echo $alertstat ?></td>
</tr>
<?php
}
mysql_free_result($result);
?>

</tbody>
</table>
</td>
</tr>
</tbody>
</table>

