<?php
/*
Threshold plugin 2.1a for cacti 8.6c

Copyright 2005 Aurelio DeSimone
adesimone@ciscoconfigbuilder.com
http://www.ciscoconfigbuilder.com

Many contributions from Ranko Zivojnovic <ranko@spidernet.net>

Some code may have been used from other parts of cacti - copyright of Ian Berry
*/


include("./include/auth.php");
//include("./thold/thold-functions.php");
include_once($config["include_path"] . "/top_header.php");
include_once($config["library_path"] . "/rrd.php");
include_once($config["library_path"] . "/thold-functions.php");


if (isset($_REQUEST["hostid"])) {
	$hostid=$_REQUEST["hostid"];
	} else {
	$_REQUEST["hostid"] = ""; 
	}

if (isset($_REQUEST["rra"])) {  
	$rra=$_REQUEST['rra'];
	} else {
	$_REQUEST["rra"] = ""; 
	}

if (!isset($_REQUEST["action"])) {  $_REQUEST["action"] = ""; }

switch($_REQUEST["action"]) {
	case "save":
		save_thold();
		break;
	case "autocreate":
		autocreate($hostid);
		exit("DONE");
}

$thold_cfg = db_fetch_assoc("select * from tholdset limit 1");
$thold_cfg = $thold_cfg[0];
$sqlq = mysql_query("SELECT * FROM thold where rra='$rra'");
$total = mysql_num_rows($sqlq);
$myrow = mysql_fetch_array($sqlq);

mysql_free_result($sqlq);

$t = db_fetch_assoc("select id,name,name_cache from data_template_data where local_data_id=" . $rra . " LIMIT 1");
$desc = $t[0]["name_cache"];
unset($t);

$rrdsql = mysql_fetch_array(mysql_query("SELECT id FROM data_template_rrd WHERE local_data_id=$rra LIMIT 1"));
$rrdlookup = $rrdsql["id"];

$template_data_rrds = db_fetch_assoc("select id,data_source_name from data_template_rrd where local_data_id=" . $rra . " order by id");
$grapharr = db_fetch_assoc("SELECT DISTINCT local_graph_id FROM graph_templates_item WHERE task_item_id=$rrdlookup");

if ($total == 0) {
	// Take the first one available
	$graph = $grapharr[0]["local_graph_id"];
} else {
	$graph = $myrow["element"];
};

?>
<table width="98%" align="center">
        <tr>
                <td class="textArea">
	<?php 
		if (isset($banner)) { 
			echo $banner . "<br><br>";
			
		}; ?>

<form name="THold" action=thold.php method=post>
	<input type='hidden' name='rra' value='<?php echo $rra?>'>
	<input type='hidden' name='hostid' value='<?php echo $hostid?>'>
	Data Source Description: <br><strong><?php echo $desc?></strong><br><br>
<!-- 	Threshold: <br><input type='text' name='thold' size='10' maxlength='20' value="<?php echo $myrow["threshold"] ?>" ><br>
-->
	Associated Graph (graphs that use this RRD): <br>
	<select name='element'>
<?php
foreach($grapharr as $g) {
	$graph_desc = db_fetch_assoc("SELECT local_graph_id,title,title_cache FROM graph_templates_graph WHERE local_graph_id = " . $g["local_graph_id"]);
	
	echo "<option value=" . $graph_desc[0]["local_graph_id"];
	if($graph_desc[0]["local_graph_id"] == $graph) echo " selected";
	echo "> " . $graph_desc[0]["local_graph_id"] . " - " . $graph_desc[0]["title_cache"] . " </option>\n";
	
}
?>
	</select>
	<br>
<br>


                </td>
	<td>
	<img src="graph_image.php?local_graph_id=<?php echo $graph ?>&rra_id=1&graph_start=-32400&graph_height=100&graph_width=300&graph_nolegend=true">
	</td>
        </tr>
</table>
<?php
/* select the first "rrd" of this data source by default */
if (empty($_GET["view_rrd"])) {
	if(isset($_POST["data_template_rrd_id"])) {
		$_GET["view_rrd"] = $_POST["data_template_rrd_id"];
	} else {
		$_GET["view_rrd"] = (isset($template_data_rrds[0]["id"]) ? $template_data_rrds[0]["id"] : "0");
	}
}

/* get more information about the rrd we chose */
if (!empty($_GET["view_rrd"])) {
	$template_rrd = db_fetch_row("select * from data_template_rrd where id=" . $_GET["view_rrd"]);
}

//-----------------------------
// Tabs (if more than one item)
//-----------------------------
$i = 0;
$ds = 0;
if (isset($template_data_rrds)) {
	if (sizeof($template_data_rrds) > 1) {
		/* draw the data source tabs on the top of the page */
		print "	<table class='tabs' width='98%' cellspacing='0' cellpadding='3' align='center'>
		<tr>\n";
		
		foreach ($template_data_rrds as $template_data_rrd) {
			if($template_data_rrd["id"] == $_GET["view_rrd"]) $ds = $template_data_rrd["data_source_name"];

			$item = db_fetch_assoc("select * from thold_data where data_id = " . $template_data_rrd["id"]);
			$item = count($item) > 0 ? $item[0] : $item;
			
			if(count($item) == 0) {
				$cur_setting = "n/a";
			} else {
				$cur_setting = "Hi: " . ($item["thold_hi"] == "" ? "n/a" : $item["thold_hi"]);
				$cur_setting .= " Lo: " . ($item["thold_low"] == "" ? "n/a" : $item["thold_low"]);
				$cur_setting .= " BL: " . $item["bl_enabled"];
			}
			$tab_len = max(strlen($cur_setting), strlen($template_data_rrd["data_source_name"]));
			if($cur_setting == "n/a") { $cur_setting = "<font color='red'>" . $cur_setting . "</font>"; }

			$i++;
			echo "	<td bgcolor=" . (($template_data_rrd["id"] == $_GET["view_rrd"]) ? "'silver'" : "'#DFDFDF'");
			echo " nowrap='nowrap' width='" . (($tab_len * 8) + 30) . "' align='center' class='tab'>";
			echo "<span class='textHeader'><a href='thold.php?rra=" . $rra . "&view_rrd=" . $template_data_rrd["id"] . "'>$i: " . $template_data_rrd["data_source_name"] . "</a><br>";
			echo $cur_setting;
			echo "</span>\n</td>\n<td width='1'></td>\n";
			unset($thold_item_data);
		}
		
		print "
		<td></td>\n
		</tr>
		</table>\n";
		
	}elseif (sizeof($template_data_rrds) == 1) {
		$_GET["view_rrd"] = $template_data_rrds[0]["id"];
	}
}

html_start_box("", "98%", $colors["header"], "3", "center", "");
//------------------------
// Data Source Item header
//------------------------
print "	<tr>
	<td colspan=2 bgcolor='#" . $colors["header"] . "' class='textHeaderDark'>
	<strong>Data Source Item</strong> [" . (isset($template_rrd) ? $template_rrd["data_source_name"] : "") . "] " .
	" - <strong>Current value: </strong>[" . get_current_value($rra, $ds) .
        "]</td>
	</tr>\n";

//----------------------
// Data Source Item Form
//----------------------
$thold_item_data = db_fetch_assoc("select * from thold_data where data_id = " . $_GET["view_rrd"]);
$thold_item_data = count($thold_item_data) > 0 ? $thold_item_data[0] : $thold_item_data;

$form_array = array(
		"general_header" => array(
			"friendly_name" => "Mandatory settings",
			"method" => "spacer",
		),
		
		"thold_hi" => array(
			"friendly_name" => "High Threshold",
			"method" => "textbox",
			"max_length" => 12,
			"description" => "If set and data source value goes above this number, alert will be triggered",
			"value" => isset($thold_item_data["thold_hi"]) ? $thold_item_data["thold_hi"] : "" 
		),
		
		"thold_low" => array(
			"friendly_name" => "Low Threshold",
			"method" => "textbox",
			"max_length" => 12,
			"description" => "If set and data source value goes below this number, alert will be triggered",
			"value" => isset($thold_item_data["thold_low"]) ? $thold_item_data["thold_low"] : ""
		),
		
		"thold_fail_trigger" => array(
			"friendly_name" => "Trigger Count",
			"method" => "textbox",
			"max_length" => 3,
			"size" => 3,
			"description" => "Number of consecutive times the data source must be in breach of the threshold for an alert to be raised.<br>Leave empty to use default value (<b>Default: " . read_config_option("alert_trigger") . " cycles</b>)",
			"value" => isset($thold_item_data["thold_fail_trigger"]) ? $thold_item_data["thold_fail_trigger"] : ""
		),
		
		"baseline_header" => array(
			"friendly_name" => "Baseline monitoring",
			"method" => "spacer",
		),
		
		"bl_enabled" => array(
			"friendly_name" => "Baseline monitoring",
			"method" => "checkbox",
			"default" => "off",
			"description" => "When enabled, baseline monitoring checks the current data source value against a value in the past. The available range of values is retrieved and a minimum and maximum values are taken as a respective baseline reference. The precedence however is on the &quot;hard&quot; thresholds above.",
			"value" => isset($thold_item_data["bl_enabled"]) ? $thold_item_data["bl_enabled"] : ""
		),
		
		"bl_ref_time" => array(
			"friendly_name" => "Reference in the past",
			"method" => "textbox",
			"max_length" => 12,
			"default" => 0,
			"description" => "Specifies the relative point in the past that will be used as a reference. The value represents seconds, so for a day you would specify 86400, for a week 604800, etc.",
			"value" => isset($thold_item_data["bl_ref_time"]) ? $thold_item_data["bl_ref_time"] : ""
		),
		
		"bl_ref_time_range" => array(
			"friendly_name" => "Time range",
			"method" => "textbox",
			"max_length" => 12,
			"default" => 0,
			"description" => "Specifies the time range of values in seconds to be taken from the reference in the past",
			"value" => isset($thold_item_data["bl_ref_time_range"]) ? $thold_item_data["bl_ref_time_range"] : ""
		),
		
		"bl_pct_up" => array(
			"friendly_name" => "Baseline deviation UP",
			"method" => "textbox",
			"max_length" => 3,
			"size" => 3,
			"description" => "Specifies allowed deviation in percentage for the upper bound threshold. If not set, upper bound threshold will not be checked at all.",
			"value" => isset($thold_item_data["bl_pct_up"]) ? $thold_item_data["bl_pct_up"] : ""
		),
		
		"bl_pct_down" => array(
			"friendly_name" => "Baseline deviation DOWN",
			"method" => "textbox",
			"max_length" => 3,
			"size" => 3,
			"description" => "Specifies allowed deviation in percentage for the lower bound threshold. If not set, lower bound threshold will not be checked at all.",
			"value" => isset($thold_item_data["bl_pct_down"]) ? $thold_item_data["bl_pct_down"] : ""
		),
		
		"bl_fail_trigger" => array(
			"friendly_name" => "Baseline Trigger Count",
			"method" => "textbox",
			"max_length" => 3,
			"size" => 3,
			"description" => "Number of consecutive times the data source must be in breach of the baseline threshold for an alert to be raised.<br>Leave empty to use default value (<b>Default: " . read_config_option("alert_bl_trigger") . " cycles</b>)",
			"value" => isset($thold_item_data["bl_fail_trigger"]) ? $thold_item_data["bl_fail_trigger"] : ""
		),
		
		"other_header" => array(
			"friendly_name" => "Other setting",
			"method" => "spacer",
		),
		
		"repeat_alert" => array(
			"friendly_name" => "Re-Alert Cycle",
			"method" => "textbox",
			"max_length" => 3,
			"size" => 3,
			"description" => "Repeat alert after specified number of cycles.<br>Leave empty to use default value (<b>Default: " . read_config_option("alert_repeat") . " cycles</b>)",
			"value" => isset($thold_item_data["repeat_alert"]) ? $thold_item_data["repeat_alert"] : ""
		),
		
		"notify_default" => array(
			"friendly_name" => "Send notifications to default alert address",
			"method" => "drop_array",
			"default" => "NULL",
			"description" => "Determines if the notifications will be sent to e-mail address specified in global settings.",
			"value" => isset($thold_item_data["notify_default"]) ? $thold_item_data["notify_default"] : "",
			"array" => array("NULL" => "Use global control: " . (read_config_option("alert_notify_default") == "on" ? "On" : "Off"),
					"on" => "Force: On",
					"off" => "Force: Off")
		),
		
		"notify_extra" => array(
			"friendly_name" => "Alert E-Mail",
			"method" => "textbox",
			"max_length" => 255,
			"description" => "You may specify here extra e-mails to receive alerts for this data source (comma separated)",
			"value" => isset($thold_item_data["notify_extra"]) ? $thold_item_data["notify_extra"] : ""
		),
		
	);

draw_edit_form(
	array(
		"config" => array(
			"no_form_tag" => true
			),
		"fields" => $form_array + array(
			"data_template_rrd_id" => array(
				"method" => "hidden",
				"value" => (isset($template_rrd) ? $template_rrd["id"] : "0")
			)
		)
		)
	);

html_end_box();
form_save_button("thold.php?rra=" . $rra . "&view_rrd=" . $_GET["view_rrd"], "save");

unset($template_data_rrds);
?>
<!-- Make it look intelligent :) -->
<script language="JavaScript">
function BL_EnableDisable()
{
	var _f = document.THold;
	var status = !_f.bl_enabled.checked;
	
	_f.bl_ref_time.disabled = status;
	_f.bl_ref_time_range.disabled = status;
	_f.bl_pct_down.disabled = status;
	_f.bl_pct_up.disabled = status;
	_f.bl_fail_trigger.disabled = status;
}

BL_EnableDisable();
document.THold.bl_enabled.onclick = BL_EnableDisable;

</script>
<?php
include("./include/bottom_footer.php");
?>
